Rails.application.routes.draw do
  post "/validate",                        to: "candidate#validate",         as: :validate_candidate
   get "/welcome",                         to: "candidate#welcome",          as: :welcome
   get "/thankyou",                        to: "candidate#thankyou",         as: :thankyou
   get "/saved",                           to: "candidate#saved",            as: :saved

  post "/question(/:answer_id)",           to: "candidate#update_answer",    as: :post_answer
   get "/question(/:question_id)",         to: "candidate#question",         as: :question
   get "/live-coder-entry/:question_id",   to: "candidate#live_coder",       as: :live_coder

  post "/summary",                         to: "candidate#update_summary",   as: :post_summary
   get "/summary",                         to: "candidate#summary",          as: :summary

   get "/review/logout",                   to: "review#logout",              as: :review_logout
  post "/review/login",                    to: "review#auth",                as: :review_auth
   get "/review/login",                    to: "review#login",               as: :review_login
   get "/review",                          to: "review#index",               as: :review
   get "/review/:test_hash",               to: "review#view",                as: :review_test

   get "/recruiter",                       to: "recruiter#index",            as: :recruiter
   get "/recruiter/new-candidate",         to: "recruiter#new",              as: :new_candidate
  post "/recruiter/new-candidate",         to: "recruiter#create",           as: :create_candidate
   get "/recruiter/logout",                to: "recruiter#logout",           as: :recruiter_logout
   get "/recruiter/login",                 to: "recruiter#login",            as: :recruiter_login
  post "/recruiter/login",                 to: "recruiter#auth",             as: :recruiter_auth

  root to: "candidate#welcome"

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end
